diff --git a/gcc/testsuite/gdc.dg/dg.exp b/gcc/testsuite/gdc.dg/dg.exp
index 15cbe1c4168..47a16da3f0a 100644
--- a/gcc/testsuite/gdc.dg/dg.exp
+++ b/gcc/testsuite/gdc.dg/dg.exp
@@ -19,32 +19,18 @@
 # Load support procs.
 load_lib gdc-dg.exp
 
-# The default option list can be overridden by
-# TORTURE_OPTIONS="{ { list1 } ... { listN } }"
-
-if ![info exists TORTURE_OPTIONS] {
-    set TORTURE_OPTIONS [list \
-	{ -O0 } { -O1 } { -O2 } { -O3 } { -Os } \
-	{ -O0 -frelease } { -O0 -g } { -O0 -frelease -g } \
-	{ -O1 -frelease } { -O1 -g } { -O1 -frelease -g } \
-	{ -O2 -frelease } { -O2 -g } { -O2 -frelease -g } \
-	{ -O3 -frelease } { -O3 -g } { -O3 -frelease -g } \
-	{ -Os -frelease } { -Os -g } { -Os -frelease -g }]
+# If a testcase doesn't have special options, use these.
+global DEFAULT_DFLAGS
+if ![info exists DEFAULT_DFLAGS] then {
+    set DEFAULT_DFLAGS ""
 }
 
 # Initialize `dg'.
 dg-init
 
-# Initialize use of torture lists.
-torture-init
-set-torture-options $TORTURE_OPTIONS
-
 # Main loop.
 gdc-dg-runtest [lsort \
-       [glob -nocomplain $srcdir/$subdir/*.d ] ] "" ""
-
-# Finalize use of torture lists.
-torture-finish
+       [glob -nocomplain $srcdir/$subdir/*.d ] ] "" $DEFAULT_DFLAGS
 
 # All done.
 dg-finish
diff --git a/gcc/testsuite/gdc.dg/gdc115.d b/gcc/testsuite/gdc.dg/torture/gdc115.d
similarity index 89%
rename from gcc/testsuite/gdc.dg/gdc115.d
rename to gcc/testsuite/gdc.dg/torture/gdc115.d
index 8eca2eb19c2..79693e8d329 100644
--- a/gcc/testsuite/gdc.dg/gdc115.d
+++ b/gcc/testsuite/gdc.dg/torture/gdc115.d
@@ -1,5 +1,5 @@
 // https://bugzilla.gdcproject.org/show_bug.cgi?id=115
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 void main()
diff --git a/gcc/testsuite/gdc.dg/gdc131.d b/gcc/testsuite/gdc.dg/torture/gdc131.d
similarity index 89%
rename from gcc/testsuite/gdc.dg/gdc131.d
rename to gcc/testsuite/gdc.dg/torture/gdc131.d
index 394a90998e2..63502ffceae 100644
--- a/gcc/testsuite/gdc.dg/gdc131.d
+++ b/gcc/testsuite/gdc.dg/torture/gdc131.d
@@ -1,5 +1,5 @@
 // https://bugzilla.gdcproject.org/show_bug.cgi?id=131
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 struct S131
diff --git a/gcc/testsuite/gdc.dg/gdc141.d b/gcc/testsuite/gdc.dg/torture/gdc141.d
similarity index 89%
rename from gcc/testsuite/gdc.dg/gdc141.d
rename to gcc/testsuite/gdc.dg/torture/gdc141.d
index 9a3d5c56c3e..315811cda18 100644
--- a/gcc/testsuite/gdc.dg/gdc141.d
+++ b/gcc/testsuite/gdc.dg/torture/gdc141.d
@@ -1,5 +1,5 @@
 // https://bugzilla.gdcproject.org/show_bug.cgi?id=141
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 bool test141(int a)
diff --git a/gcc/testsuite/gdc.dg/gdc17.d b/gcc/testsuite/gdc.dg/torture/gdc17.d
similarity index 95%
rename from gcc/testsuite/gdc.dg/gdc17.d
rename to gcc/testsuite/gdc.dg/torture/gdc17.d
index 0fd58479835..cfc569429b8 100644
--- a/gcc/testsuite/gdc.dg/gdc17.d
+++ b/gcc/testsuite/gdc.dg/torture/gdc17.d
@@ -1,5 +1,5 @@
 // https://bugzilla.gdcproject.org/show_bug.cgi?id=17
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 /**
diff --git a/gcc/testsuite/gdc.dg/gdc171.d b/gcc/testsuite/gdc.dg/torture/gdc171.d
similarity index 95%
rename from gcc/testsuite/gdc.dg/gdc171.d
rename to gcc/testsuite/gdc.dg/torture/gdc171.d
index f8b7fde70a6..a6c5ea6986a 100644
--- a/gcc/testsuite/gdc.dg/gdc171.d
+++ b/gcc/testsuite/gdc.dg/torture/gdc171.d
@@ -1,5 +1,5 @@
 // https://bugzilla.gdcproject.org/show_bug.cgi?id=171
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 void test171a()
diff --git a/gcc/testsuite/gdc.dg/gdc179.d b/gcc/testsuite/gdc.dg/torture/gdc179.d
similarity index 93%
rename from gcc/testsuite/gdc.dg/gdc179.d
rename to gcc/testsuite/gdc.dg/torture/gdc179.d
index 72fe0b74e4b..a64ca7d452a 100644
--- a/gcc/testsuite/gdc.dg/gdc179.d
+++ b/gcc/testsuite/gdc.dg/torture/gdc179.d
@@ -1,5 +1,5 @@
 // https://bugzilla.gdcproject.org/show_bug.cgi?id=179
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 import core.stdc.stdio;
diff --git a/gcc/testsuite/gdc.dg/gdc186.d b/gcc/testsuite/gdc.dg/torture/gdc186.d
similarity index 97%
rename from gcc/testsuite/gdc.dg/gdc186.d
rename to gcc/testsuite/gdc.dg/torture/gdc186.d
index 4a1a91a709c..282167c51f2 100644
--- a/gcc/testsuite/gdc.dg/gdc186.d
+++ b/gcc/testsuite/gdc.dg/torture/gdc186.d
@@ -1,5 +1,5 @@
 // https://bugzilla.gdcproject.org/show_bug.cgi?id=186
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 struct S186
diff --git a/gcc/testsuite/gdc.dg/gdc187.d b/gcc/testsuite/gdc.dg/torture/gdc187.d
similarity index 94%
rename from gcc/testsuite/gdc.dg/gdc187.d
rename to gcc/testsuite/gdc.dg/torture/gdc187.d
index 2f469ad81f6..60fbafc26a0 100644
--- a/gcc/testsuite/gdc.dg/gdc187.d
+++ b/gcc/testsuite/gdc.dg/torture/gdc187.d
@@ -1,5 +1,5 @@
 // https://bugzilla.gdcproject.org/show_bug.cgi?id=187
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 align(1) struct S187b
diff --git a/gcc/testsuite/gdc.dg/gdc191.d b/gcc/testsuite/gdc.dg/torture/gdc191.d
similarity index 99%
rename from gcc/testsuite/gdc.dg/gdc191.d
rename to gcc/testsuite/gdc.dg/torture/gdc191.d
index 4d2ca9df0ca..f414603cf7b 100644
--- a/gcc/testsuite/gdc.dg/gdc191.d
+++ b/gcc/testsuite/gdc.dg/torture/gdc191.d
@@ -1,5 +1,5 @@
 // https://bugzilla.gdcproject.org/show_bug.cgi?id=191
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 class C191
diff --git a/gcc/testsuite/gdc.dg/gdc198.d b/gcc/testsuite/gdc.dg/torture/gdc198.d
similarity index 97%
rename from gcc/testsuite/gdc.dg/gdc198.d
rename to gcc/testsuite/gdc.dg/torture/gdc198.d
index 09daf85045d..144de6135f6 100644
--- a/gcc/testsuite/gdc.dg/gdc198.d
+++ b/gcc/testsuite/gdc.dg/torture/gdc198.d
@@ -1,5 +1,5 @@
 // https://bugzilla.gdcproject.org/show_bug.cgi?id=198
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 struct S198a
diff --git a/gcc/testsuite/gdc.dg/gdc200.d b/gcc/testsuite/gdc.dg/torture/gdc200.d
similarity index 90%
rename from gcc/testsuite/gdc.dg/gdc200.d
rename to gcc/testsuite/gdc.dg/torture/gdc200.d
index 585d60fe763..c41d8eac8aa 100644
--- a/gcc/testsuite/gdc.dg/gdc200.d
+++ b/gcc/testsuite/gdc.dg/torture/gdc200.d
@@ -1,5 +1,5 @@
 // https://bugzilla.gdcproject.org/show_bug.cgi?id=200
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 void test200a(double x, double y)
diff --git a/gcc/testsuite/gdc.dg/gdc210.d b/gcc/testsuite/gdc.dg/torture/gdc210.d
similarity index 97%
rename from gcc/testsuite/gdc.dg/gdc210.d
rename to gcc/testsuite/gdc.dg/torture/gdc210.d
index 0f560731b22..7c7dad8ce83 100644
--- a/gcc/testsuite/gdc.dg/gdc210.d
+++ b/gcc/testsuite/gdc.dg/torture/gdc210.d
@@ -1,5 +1,5 @@
 // https://bugzilla.gdcproject.org/show_bug.cgi?id=210
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 struct S210
diff --git a/gcc/testsuite/gdc.dg/gdc240.d b/gcc/testsuite/gdc.dg/torture/gdc240.d
similarity index 89%
rename from gcc/testsuite/gdc.dg/gdc240.d
rename to gcc/testsuite/gdc.dg/torture/gdc240.d
index 76f6dcf8db7..d37f23568a7 100644
--- a/gcc/testsuite/gdc.dg/gdc240.d
+++ b/gcc/testsuite/gdc.dg/torture/gdc240.d
@@ -1,5 +1,5 @@
 // https://bugzilla.gdcproject.org/show_bug.cgi?id=240
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 void test240(int a, int b)
diff --git a/gcc/testsuite/gdc.dg/gdc242b.d b/gcc/testsuite/gdc.dg/torture/gdc242b.d
similarity index 91%
rename from gcc/testsuite/gdc.dg/gdc242b.d
rename to gcc/testsuite/gdc.dg/torture/gdc242b.d
index cfba4b484b3..d7070512426 100644
--- a/gcc/testsuite/gdc.dg/gdc242b.d
+++ b/gcc/testsuite/gdc.dg/torture/gdc242b.d
@@ -1,5 +1,5 @@
 // https://bugzilla.gdcproject.org/show_bug.cgi?id=242
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 struct S242
diff --git a/gcc/testsuite/gdc.dg/gdc248.d b/gcc/testsuite/gdc.dg/torture/gdc248.d
similarity index 94%
rename from gcc/testsuite/gdc.dg/gdc248.d
rename to gcc/testsuite/gdc.dg/torture/gdc248.d
index 0fd0277bd46..462b687487d 100644
--- a/gcc/testsuite/gdc.dg/gdc248.d
+++ b/gcc/testsuite/gdc.dg/torture/gdc248.d
@@ -1,5 +1,5 @@
 // https://bugzilla.gdcproject.org/show_bug.cgi?id=248
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 class C248b
diff --git a/gcc/testsuite/gdc.dg/gdc250.d b/gcc/testsuite/gdc.dg/torture/gdc250.d
similarity index 90%
rename from gcc/testsuite/gdc.dg/gdc250.d
rename to gcc/testsuite/gdc.dg/torture/gdc250.d
index c8182da8bb1..c5b7d60dab6 100644
--- a/gcc/testsuite/gdc.dg/gdc250.d
+++ b/gcc/testsuite/gdc.dg/torture/gdc250.d
@@ -1,5 +1,5 @@
 // https://bugzilla.gdcproject.org/show_bug.cgi?id=250
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 void main()
diff --git a/gcc/testsuite/gdc.dg/gdc273.d b/gcc/testsuite/gdc.dg/torture/gdc273.d
similarity index 91%
rename from gcc/testsuite/gdc.dg/gdc273.d
rename to gcc/testsuite/gdc.dg/torture/gdc273.d
index b5d2b103593..268d8d0ce4a 100644
--- a/gcc/testsuite/gdc.dg/gdc273.d
+++ b/gcc/testsuite/gdc.dg/torture/gdc273.d
@@ -1,5 +1,5 @@
 // https://bugzilla.gdcproject.org/show_bug.cgi?id=273
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 class B273
diff --git a/gcc/testsuite/gdc.dg/gdc283.d b/gcc/testsuite/gdc.dg/torture/gdc283.d
similarity index 96%
rename from gcc/testsuite/gdc.dg/gdc283.d
rename to gcc/testsuite/gdc.dg/torture/gdc283.d
index ca7ad3ff3f5..f7316f79a49 100644
--- a/gcc/testsuite/gdc.dg/gdc283.d
+++ b/gcc/testsuite/gdc.dg/torture/gdc283.d
@@ -1,5 +1,6 @@
 // https://bugzilla.gdcproject.org/show_bug.cgi?id=283
-// { dg-do run { target hw } }
+// { dg-do run }
+// { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 struct Impl
 {
diff --git a/gcc/testsuite/gdc.dg/gdc285.d b/gcc/testsuite/gdc.dg/torture/gdc285.d
similarity index 91%
rename from gcc/testsuite/gdc.dg/gdc285.d
rename to gcc/testsuite/gdc.dg/torture/gdc285.d
index f94ffb5f152..30ea373b64c 100644
--- a/gcc/testsuite/gdc.dg/gdc285.d
+++ b/gcc/testsuite/gdc.dg/torture/gdc285.d
@@ -1,5 +1,5 @@
 // https://bugzilla.gdcproject.org/show_bug.cgi?id=285
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 inout(char)[] test285(inout(char)* s) @nogc @system pure nothrow
diff --git a/gcc/testsuite/gdc.dg/gdc286.d b/gcc/testsuite/gdc.dg/torture/gdc286.d
similarity index 95%
rename from gcc/testsuite/gdc.dg/gdc286.d
rename to gcc/testsuite/gdc.dg/torture/gdc286.d
index 2536ef6e26a..9b6bc65be2d 100644
--- a/gcc/testsuite/gdc.dg/gdc286.d
+++ b/gcc/testsuite/gdc.dg/torture/gdc286.d
@@ -1,5 +1,5 @@
 // https://bugzilla.gdcproject.org/show_bug.cgi?id=286
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 void main()
diff --git a/gcc/testsuite/gdc.dg/gdc309.d b/gcc/testsuite/gdc.dg/torture/gdc309.d
similarity index 96%
rename from gcc/testsuite/gdc.dg/gdc309.d
rename to gcc/testsuite/gdc.dg/torture/gdc309.d
index bbcb6e7a412..d14634a2f1f 100644
--- a/gcc/testsuite/gdc.dg/gdc309.d
+++ b/gcc/testsuite/gdc.dg/torture/gdc309.d
@@ -1,5 +1,5 @@
 // https://bugzilla.gdcproject.org/show_bug.cgi?id=309
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 void main()
diff --git a/gcc/testsuite/gdc.dg/gdc35.d b/gcc/testsuite/gdc.dg/torture/gdc35.d
similarity index 97%
rename from gcc/testsuite/gdc.dg/gdc35.d
rename to gcc/testsuite/gdc.dg/torture/gdc35.d
index 773a78a73f5..111e05612b4 100644
--- a/gcc/testsuite/gdc.dg/gdc35.d
+++ b/gcc/testsuite/gdc.dg/torture/gdc35.d
@@ -1,5 +1,5 @@
 // https://bugzilla.gdcproject.org/show_bug.cgi?id=35
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 /**
diff --git a/gcc/testsuite/gdc.dg/gdc36.d b/gcc/testsuite/gdc.dg/torture/gdc36.d
similarity index 98%
rename from gcc/testsuite/gdc.dg/gdc36.d
rename to gcc/testsuite/gdc.dg/torture/gdc36.d
index fbb876c28b3..3adb7f2fe98 100644
--- a/gcc/testsuite/gdc.dg/gdc36.d
+++ b/gcc/testsuite/gdc.dg/torture/gdc36.d
@@ -1,7 +1,7 @@
 // https://bugzilla.gdcproject.org/show_bug.cgi?id=36
 // { dg-additional-sources "imports/gdc36.d" }
 // { dg-options "-I $srcdir/gdc.dg" }
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 module gdc36;
diff --git a/gcc/testsuite/gdc.dg/gdc51.d b/gcc/testsuite/gdc.dg/torture/gdc51.d
similarity index 93%
rename from gcc/testsuite/gdc.dg/gdc51.d
rename to gcc/testsuite/gdc.dg/torture/gdc51.d
index e6ffbd470b0..22f9bdad754 100644
--- a/gcc/testsuite/gdc.dg/gdc51.d
+++ b/gcc/testsuite/gdc.dg/torture/gdc51.d
@@ -1,5 +1,5 @@
 // https://bugzilla.gdcproject.org/show_bug.cgi?id=51
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 struct S51
diff --git a/gcc/testsuite/gdc.dg/gdc57.d b/gcc/testsuite/gdc.dg/torture/gdc57.d
similarity index 90%
rename from gcc/testsuite/gdc.dg/gdc57.d
rename to gcc/testsuite/gdc.dg/torture/gdc57.d
index b378286066a..579067bc212 100644
--- a/gcc/testsuite/gdc.dg/gdc57.d
+++ b/gcc/testsuite/gdc.dg/torture/gdc57.d
@@ -1,5 +1,5 @@
 // https://bugzilla.gdcproject.org/show_bug.cgi?id=57
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 struct S57
diff --git a/gcc/testsuite/gdc.dg/gdc66.d b/gcc/testsuite/gdc.dg/torture/gdc66.d
similarity index 87%
rename from gcc/testsuite/gdc.dg/gdc66.d
rename to gcc/testsuite/gdc.dg/torture/gdc66.d
index f499c8352af..a59bcf68e6f 100644
--- a/gcc/testsuite/gdc.dg/gdc66.d
+++ b/gcc/testsuite/gdc.dg/torture/gdc66.d
@@ -1,5 +1,5 @@
 // https://bugzilla.gdcproject.org/show_bug.cgi?id=66
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 void main()
diff --git a/gcc/testsuite/gdc.dg/imports/gdc36.d b/gcc/testsuite/gdc.dg/torture/imports/gdc36.d
similarity index 100%
rename from gcc/testsuite/gdc.dg/imports/gdc36.d
rename to gcc/testsuite/gdc.dg/torture/imports/gdc36.d
diff --git a/gcc/testsuite/gdc.dg/init1.d b/gcc/testsuite/gdc.dg/torture/init1.d
similarity index 83%
rename from gcc/testsuite/gdc.dg/init1.d
rename to gcc/testsuite/gdc.dg/torture/init1.d
index 679ad15460e..ce8c940a57b 100644
--- a/gcc/testsuite/gdc.dg/init1.d
+++ b/gcc/testsuite/gdc.dg/torture/init1.d
@@ -1,4 +1,4 @@
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-options "-fno-druntime" }
 // 'a' should not be default initialized to -1.
 static char a = void;
diff --git a/gcc/testsuite/gdc.dg/pr92309.d b/gcc/testsuite/gdc.dg/torture/pr92309.d
similarity index 91%
rename from gcc/testsuite/gdc.dg/pr92309.d
rename to gcc/testsuite/gdc.dg/torture/pr92309.d
index 01ebc40d336..03ff21974eb 100644
--- a/gcc/testsuite/gdc.dg/pr92309.d
+++ b/gcc/testsuite/gdc.dg/torture/pr92309.d
@@ -1,5 +1,5 @@
 // https://gcc.gnu.org/bugzilla/show_bug.cgi?id=92309
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 union U
diff --git a/gcc/testsuite/gdc.dg/pr94424.d b/gcc/testsuite/gdc.dg/torture/pr94424.d
similarity index 93%
rename from gcc/testsuite/gdc.dg/pr94424.d
rename to gcc/testsuite/gdc.dg/torture/pr94424.d
index b9f9fac8957..2910c9ae139 100644
--- a/gcc/testsuite/gdc.dg/pr94424.d
+++ b/gcc/testsuite/gdc.dg/torture/pr94424.d
@@ -1,6 +1,6 @@
 // https://gcc.gnu.org/bugzilla/show_bug.cgi?id=94424
 // { dg-additional-options "-fmain -funittest" }
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 @safe unittest
 {
diff --git a/gcc/testsuite/gdc.dg/pr94777b.d b/gcc/testsuite/gdc.dg/torture/pr94777b.d
similarity index 99%
rename from gcc/testsuite/gdc.dg/pr94777b.d
rename to gcc/testsuite/gdc.dg/torture/pr94777b.d
index a230adb0cd9..2f0f9d9affb 100644
--- a/gcc/testsuite/gdc.dg/pr94777b.d
+++ b/gcc/testsuite/gdc.dg/torture/pr94777b.d
@@ -1,6 +1,6 @@
 // https://gcc.gnu.org/bugzilla/show_bug.cgi?id=94777
 // { dg-additional-options "-fmain -funittest" }
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 void testVariadic(T)(int nargs, ...)
diff --git a/gcc/testsuite/gdc.dg/pr96152.d b/gcc/testsuite/gdc.dg/torture/pr96152.d
similarity index 96%
rename from gcc/testsuite/gdc.dg/pr96152.d
rename to gcc/testsuite/gdc.dg/torture/pr96152.d
index 3551614654b..86d3f9185d5 100644
--- a/gcc/testsuite/gdc.dg/pr96152.d
+++ b/gcc/testsuite/gdc.dg/torture/pr96152.d
@@ -1,6 +1,6 @@
 // https://gcc.gnu.org/bugzilla/show_bug.cgi?id=96152
 // { dg-additional-options "-fmain -funittest" }
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 auto assocArray(Keys, Values)(Keys keys, Values values)
 {
diff --git a/gcc/testsuite/gdc.dg/pr96153.d b/gcc/testsuite/gdc.dg/torture/pr96153.d
similarity index 97%
rename from gcc/testsuite/gdc.dg/pr96153.d
rename to gcc/testsuite/gdc.dg/torture/pr96153.d
index e1b8d816df0..c52b99a2f67 100644
--- a/gcc/testsuite/gdc.dg/pr96153.d
+++ b/gcc/testsuite/gdc.dg/torture/pr96153.d
@@ -1,6 +1,6 @@
 // https://gcc.gnu.org/bugzilla/show_bug.cgi?id=96153
 // { dg-additional-options "-fmain -funittest" }
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 struct Checked(T, Hook)
 {
diff --git a/gcc/testsuite/gdc.dg/pr96156.d b/gcc/testsuite/gdc.dg/torture/pr96156.d
similarity index 93%
rename from gcc/testsuite/gdc.dg/pr96156.d
rename to gcc/testsuite/gdc.dg/torture/pr96156.d
index d9359b5bcff..ac4839497a9 100644
--- a/gcc/testsuite/gdc.dg/pr96156.d
+++ b/gcc/testsuite/gdc.dg/torture/pr96156.d
@@ -1,5 +1,5 @@
 // https://gcc.gnu.org/bugzilla/show_bug.cgi?id=96156
-// { dg-do run { target hw } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 struct S96156
diff --git a/gcc/testsuite/gdc.dg/pr96157a.d b/gcc/testsuite/gdc.dg/torture/pr96157a.d
similarity index 90%
rename from gcc/testsuite/gdc.dg/pr96157a.d
rename to gcc/testsuite/gdc.dg/torture/pr96157a.d
index 11df19ea700..0e9019cb9f4 100644
--- a/gcc/testsuite/gdc.dg/pr96157a.d
+++ b/gcc/testsuite/gdc.dg/torture/pr96157a.d
@@ -1,5 +1,5 @@
 // https://gcc.gnu.org/bugzilla/show_bug.cgi?id=96157
-// { dg-do run { target native } }
+// { dg-do run }
 // { dg-skip-if "needs gcc/config.d" { ! d_runtime } }
 
 struct S
diff --git a/gcc/testsuite/gdc.dg/torture/torture.exp b/gcc/testsuite/gdc.dg/torture/torture.exp
new file mode 100644
index 00000000000..d498818aacf
--- /dev/null
+++ b/gcc/testsuite/gdc.dg/torture/torture.exp
@@ -0,0 +1,50 @@
+#   Copyright (C) 2020 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+# 
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+# 
+# You should have received a copy of the GNU General Public License
+# along with GCC; see the file COPYING3.  If not see
+# <http://www.gnu.org/licenses/>.
+
+# This harness is for tests that should be run at all optimisation levels.
+
+# Load support procs.
+load_lib gdc-dg.exp
+
+# The default option list can be overridden by
+# TORTURE_OPTIONS="{ { list1 } ... { listN } }"
+
+if ![info exists TORTURE_OPTIONS] {
+    set TORTURE_OPTIONS [list \
+	{ -O0 } { -O1 } { -O2 } { -O3 } { -Os } \
+	{ -O0 -frelease } { -O0 -g } { -O0 -frelease -g } \
+	{ -O1 -frelease } { -O1 -g } { -O1 -frelease -g } \
+	{ -O2 -frelease } { -O2 -g } { -O2 -frelease -g } \
+	{ -O3 -frelease } { -O3 -g } { -O3 -frelease -g } \
+	{ -Os -frelease } { -Os -g } { -Os -frelease -g }]
+}
+
+# Initialize `dg'.
+dg-init
+
+# Initialize use of torture lists.
+torture-init
+set-torture-options $TORTURE_OPTIONS
+
+# Main loop.
+gdc-dg-runtest [lsort \
+       [glob -nocomplain $srcdir/$subdir/*.d ] ] "" ""
+
+# Finalize use of torture lists.
+torture-finish
+
+# All done.
+dg-finish